import { OpfsDatabase } from "@sqlite.org/sqlite-wasm";
import { Relation, Model, ModelValue, QueryParams, WhereCondition, Config, PrimaryKeyValue } from "@canvas-js/modeldb";
export declare class ModelAPI {
    #private;
    readonly db: OpfsDatabase;
    readonly config: Config;
    readonly model: Model;
    columnNames: string[];
    constructor(db: OpfsDatabase, config: Config, model: Model);
    get(key: PrimaryKeyValue): ModelValue | null;
    getMany(keys: PrimaryKeyValue[]): (ModelValue | null)[];
    set(value: ModelValue): void;
    delete(key: PrimaryKeyValue): void;
    clear(): void;
    count(where?: WhereCondition): number;
    iterate(query?: QueryParams): AsyncIterable<ModelValue>;
    query(query: QueryParams): ModelValue[];
    private parseQuery;
    private getSelectExpression;
    private getWhereExpression;
}
export declare class RelationAPI {
    #private;
    readonly db: OpfsDatabase;
    readonly relation: Relation;
    readonly table: string;
    readonly sourceIndex: string;
    readonly targetIndex: string;
    constructor(db: OpfsDatabase, relation: Relation);
    get(source: PrimaryKeyValue): PrimaryKeyValue[];
    add(source: PrimaryKeyValue, targets: PrimaryKeyValue[]): void;
    delete(source: PrimaryKeyValue): void;
}
