import { type Model, type ModelValue, type PrimaryKeyValue, type PrimitiveProperty, type PrimitiveValue, type ReferenceProperty } from "@canvas-js/modeldb";
import { SqlValue } from "@sqlite.org/sqlite-wasm";
export type RecordValue = Record<string, SqlValue>;
export type RecordParams = Record<`p${string}`, SqlValue>;
export declare function encodeRecordParams(model: Model, value: ModelValue, params: Record<string, `p${string}`>): RecordParams;
export declare function decodeRecord(model: Model, record: Record<string, SqlValue>): ModelValue;
export declare function decodePrimitiveValue(modelName: string, property: PrimitiveProperty, value: SqlValue): PrimitiveValue;
export declare function decodeReferenceValue(modelName: string, property: ReferenceProperty, value: SqlValue): PrimaryKeyValue | null;
